mod loader;
use std::{error::Error, sync::Arc};

pub use loader::PipelineLoader;
use vulkano::{device::Device, format::Format, pipeline::GraphicsPipeline};

type GraphicsPipelineLoadFn =
    fn(&Arc<Device>, Format, Format) -> Result<Arc<GraphicsPipeline>, Box<dyn Error>>;

pub trait LoadableGraphicsPipeline {
    fn load(
        device: &Arc<Device>,
        swapchain_image_format: Format,
        depth_image_format: Format,
    ) -> Result<Arc<GraphicsPipeline>, Box<dyn Error>>;

    fn pipeline_name() -> &'static str;
}
